using System.Globalization;
using System;

/// <summary>
///		Summary description for mailadm_interface_settings.
/// </summary>
public partial class interfaceLite_settings : System.Web.UI.UserControl
{
	protected System.Web.UI.WebControls.RangeValidator validatorMailsPerPage;

	protected void Page_Load(object sender, System.EventArgs e)
	{
        WebMailLite.WebmailSettings settings = new WebMailLite.WebmailSettings().CreateInstance(Utils.GetWebMailDataFolder());
        
        if (!Page.IsPostBack)
		{
			intMailsPerPage.Value = settings.MailsPerPage.ToString(CultureInfo.InvariantCulture);

            string[] supportedSkins = Utils.GetSupportedSkins(Utils.GetWebMailFolder());
			for (int i = 0; i < supportedSkins.Length; i++)
			{
				txtDefaultSkin.Items.Add(supportedSkins[i]);
				if (string.Compare(supportedSkins[i], settings.DefaultSkin, true, CultureInfo.InvariantCulture) == 0)
				{
					txtDefaultSkin.SelectedIndex = i;
				}
			}

			string[] supportedLangs = Utils.GetSupportedLangs(Utils.GetWebMailDataFolder());
			for (int i = 0; i < supportedLangs.Length; i++)
			{
				txtDefaultLanguage.Items.Add(supportedLangs[i]);
				if (string.Compare(supportedLangs[i], settings.DefaultLanguage, true, CultureInfo.InvariantCulture) == 0)
				{
					txtDefaultLanguage.SelectedIndex = i;
				}
			}

			intShowTextLabels.Checked = settings.ShowTextLabels;
			intAllowAjaxVersion.Checked = settings.AllowAjax;
            
            if (settings.Mode == WebMailLite.ViewMode.WithoutPreviewPane)
                intPeviewPane.Checked = false;
            else if (settings.Mode == WebMailLite.ViewMode.WithPreviewPane)
                intPeviewPane.Checked = true;
        }
		else
		{
			Trace.Write("Interface settings is postback");
		}
	}

	#region Web Form Designer generated code
	override protected void OnInit(EventArgs e)
	{
		//
		// CODEGEN: This call is required by the ASP.NET Web Form Designer.
		//
		InitializeComponent();
		base.OnInit(e);
	}

	/// <summary>
	///		Required method for Designer support - do not modify
	///		the contents of this method with the code editor.
	/// </summary>
	private void InitializeComponent()
	{

	}
	#endregion

	protected void SubmitButton_Click(object sender, System.EventArgs e)
	{
		try
		{
            WebMailLite.WebmailSettings settings = new WebMailLite.WebmailSettings().CreateInstance(Utils.GetWebMailDataFolder());
            
            try
			{
				settings.MailsPerPage = short.Parse(intMailsPerPage.Value, CultureInfo.InvariantCulture);
				if (settings.MailsPerPage < 0)
				{
					settings.MailsPerPage = Math.Abs(settings.MailsPerPage);
				}
			}
			catch { }

			settings.DefaultSkin = txtDefaultSkin.Value;
			settings.DefaultLanguage = txtDefaultLanguage.Value;
			settings.ShowTextLabels = intShowTextLabels.Checked;
			settings.AllowAjax = intAllowAjaxVersion.Checked;

            if (intPeviewPane.Checked)
                settings.Mode = WebMailLite.ViewMode.WithPreviewPane;
            else
                settings.Mode = WebMailLite.ViewMode.WithoutPreviewPane;

			settings.SaveWebmailSettings(Utils.GetWebMailDataFolder());

            Utils.SetPageReportMessage(this.Page, WebMailLite.Constants.mailAdmSaveSuccess);
		}
		catch (Exception)
		{
            Utils.SetPageErrorMessage(this.Page, WebMailLite.Constants.mailAdmSaveUnsuccess);
		}
	}
}
