namespace WebMailLite.classic
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	/// <summary>
	///		Summary description for LowToolbar.
	/// </summary>
	public class LowToolbar : System.Web.UI.UserControl
	{
		protected string _skin = Constants.defaultSkinName;
		protected WebmailResourceManager _manager = null;
		protected int _inboxMessageCount = 0;
		protected long _inboxSize = 0;
		protected Account _acct = null;

		public string Skin
		{
			get { return _skin; }
			set { _skin = value; }
		}

		public int InboxMessageCount
		{
			get { return _inboxMessageCount; }
			set { _inboxMessageCount = value; }
		}

		public long InboxSize
		{
			get { return _inboxSize; }
			set { _inboxSize = value; }
		}

		private void Page_Load(object sender, System.EventArgs e)
		{
			_acct = Session[Constants.sessionAccount] as Account;
			_manager = (new WebmailResourceManagerCreator()).CreateResourceManager();
		}

		public string GetUsed()
		{
			WebmailSettings settings = (new WebMailSettingsCreator()).CreateWebMailSettings();

			return Convert.ToString(Math.Round(((double)_inboxSize / (double)settings.MailboxSizeLimit) * 100));
		}

		public string GetFull()
		{
			WebmailSettings settings = (new WebMailSettingsCreator()).CreateWebMailSettings();

			return Utils.GetFriendlySize(settings.MailboxSizeLimit);
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		Required method for Designer support - do not modify
		///		the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
